
Imports System
Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Text
Public Class Form1

    <Runtime.InteropServices.StructLayout(Runtime.InteropServices.LayoutKind.Sequential, Pack:=4)> _
    Structure M201
        Public comPort As Short          'Serial port COM 1 through 4
        Public scanInterval As Double      'Scan Interval in seconds
        Public numChannels As Short      'Number of channels for multi-channel scan
        Public tScan As Short            '0=single chan, 1=normal scan, 2=cal scan
        'Public chan(0 To 5) As Integer     'channel selection codes for multi-chan scan
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=6)> Public chan() As Short
        Public singleChan As Short       'channel selection code for single-chan scan
        Public lastDigInp As Short       'last valid digital input word
        Public version As Short          'microcode Version, read from Model 201
        Public channel As Short          'Current selected channel 0-7
        Public subChan As Short          'Current selected sub-channel 0-15
        'Public rawCount As Long            'unscaled A/D count 0 to 16,777,215
        Public rawCount As Integer            'unscaled A/D count 0 to 16,777,215
        Public voltage As Double           'voltage in MV
        Public digOutWord As Integer          'digital output word
        Public wordCnt As Short          'A/D word count. 2= 16-bit mode, 3= 24-bit
        Public biPolar As Short          'Unipolar/bipolar flag. 0= bi, 1= uni
        Public errorType As Integer           'error code from dll GetOneScan function
        Public filter As Short           'filter freq. 2= 400Hz, 1= 40, 0= 4Hz
        Public gain As Short             'power of 2 for gain. 1=x1, 2=x2, 4=x4, etc
        Public rate As Single              'internal data rate for A/D
        Public modeRegLo As Short        'low byte of compacted A/D mode
        Public modeRegMid As Short       'mid byte of compacted A/D mode
        Public modeRegHi As Short        'high byte of compacted A/D mode
        Public baud As Short             '0= 9600, 1= 4800, 2= 2400 . . . 5 = 300
        Public sleeping As Short         'Flag. 1= asleep, 0= awake
        Public standBy As Short          'Flag. 1= in standby, 0= operating
        Public timeBaseCnt As Integer         'not used(placeholder only), for Model 202 only
        Public average As Integer             'digital averaging in 201 (powers of 2)
        Public TXQUEUESIZE As Integer         'transmit buffer size (not used).
        Public RXQUEUESIZE As Integer         'recieve buffer size. 16 to 32767
        'Public NewScanBuff[128] As Byte    'Used for only for DLL
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=128)> Public NewScanBuff() As Byte
        'Public cbuf(25) As Byte            'Used for only for DLL
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=25)> Public cbuf() As Byte
        Public checkSum As Short         'Used for only for DLL
        Public last_char As Byte           'Used for only for DLL
        Public ConvWait As Integer            'Used for only for DLL
        'Public portStat(12) As Byte        'Used for only for DLL   'COMSTAT struct in DLL (SIZE = 12 BYTES)
        'the following is 12 bytes because that's the size of the struct
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=12)> Public portStat() As Byte
        Public fDoLabel As Byte            'Used for only for DLL
        'Public dcb(28) As Byte             'Used for only for DLL
        'the following is 80 bytes because that's the size of the struct
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=80)> Public dcb() As Byte
        Public buffer_size As Long         'Used for only for DLL
        Public fFirstDiginRequested As Byte 'Used for only for DLL
        Public Sub Initialize()
            ReDim chan(6)
            ReDim NewScanBuff(128)
            ReDim cbuf(25)
            ReDim portStat(12)
            ReDim dcb(80)
        End Sub
    End Structure
    Public ptrM201() As M201
    Public fSignedOn As Boolean = False
    Public bCurPortIndex As Byte
    Public usRetVal As Short
    Public localAvg As Short
    Public fReadCfgReturn As Boolean
    Public lNumScansInBuffer As Int32
    Declare Function SignOn Lib "Nt_m201x.dll" (ByRef ptrM201 As M201) As Short
    Declare Function SysCal Lib "Nt_m201x.dll" (ByRef ptrM201 As M201) As Short
    Declare Function SetChanCode Lib "Nt_m201x.dll" (ByRef ptrM201 As M201) As Short
    Declare Sub FilterDelay Lib "Nt_m201x.dll" (ByRef ptrM201 As M201)
    Declare Function GetConversion Lib "Nt_m201x.dll" (ByRef ptrM201 As M201) As Short
    Declare Function StartScanning Lib "Nt_m201x.dll" (ByRef ptrM201 As M201) As Short
    Declare Function StopScanning Lib "Nt_m201x.dll" (ByRef ptrM201 As M201) As Short
    Declare Function GetNumScansInBuffer Lib "Nt_m201x.dll" (ByRef ptrM201 As M201) As Int32
    Declare Function GetOneScan Lib "Nt_m201x.dll" (ByRef ptrM201 As M201) As Short
    Declare Function Gconv Lib "Nt_m201x.dll" (ByRef ptrM201 As M201) As Short

    'BOOLEAN DoDebug(T_M201 *pM201,BYTE bDebugLevel)
    'bDbgLvl = 1 just signon, 
    'bDbgLvl = 2 not used yet, 
    'bDbgLvl = 3 debug extended to many functions
    'bDbgLvl = 4 includes structure in debug file as it appears going into signon (just values set by app)
    'bDbgLvl = 5 includes a call return that creates extremely large file avoid using!
    Declare Function DoDebug Lib "Nt_m201x.dll" (ByRef ptrM201 As M201, ByVal bDbgLvl As Byte) As Byte
    Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSignon.Click
        pnlSignonWait.Left = 5
        msgs.Text = msgs.Text & "Reading config file" & vbCrLf : System.Windows.Forms.Application.DoEvents()
        scrollText()
        fReadCfgReturn = False
        msgs.Text = msgs.Text & "Signing on - wait . . ." & vbCrLf : System.Windows.Forms.Application.DoEvents()
        scrollText()
        'comPort is zero-based, so if your COM port in device manager is 1 then make this 0
        ptrM201(bCurPortIndex).comPort = 6  'easiest just to hard-code for testng (mine is COM6)

        If CByte(comboDbgLvl.Text) > 0 Then
            Dim fRetVal As Boolean
            fRetVal = DoDebug(ptrM201(bCurPortIndex), CByte(comboDbgLvl.Text))
        End If

        ptrM201(bCurPortIndex).timeBaseCnt = -1
        'ptrM201(bCurPortIndex).timeBaseCnt = 0 'just testing

        usRetVal = SignOn(ptrM201(bCurPortIndex))
        msgs.Text = msgs.Text & "SignOn return val: " & usRetVal & vbCrLf : System.Windows.Forms.Application.DoEvents()
        scrollText()
        If usRetVal Then
            msgs.Text = msgs.Text & "calibrating - wait . . ." & vbCrLf : System.Windows.Forms.Application.DoEvents()
            scrollText()
            usRetVal = SysCal(ptrM201(bCurPortIndex))      'set channel and subchannel
            'ptrM201(bCurPortIndex).channel = 7  'just for testing
            'usRetVal = SetChanCode(ptrM201(bCurPortIndex))      'set channel and subchannel
            'FilterDelay(ptrM201(bCurPortIndex))

            fSignedOn = True
            comboChan.Text = 7
            FilterDelay(ptrM201(bCurPortIndex))

            usRetVal = GetConversion(ptrM201(bCurPortIndex)) 'returns millivolts to struct
            msgs.Text = msgs.Text & Format(ptrM201(bCurPortIndex).voltage / 1000, "#.000000") & vbCrLf
            scrollText()
            btnGetVolts.Enabled = True
            btnTimer.Enabled = True
            comboChan.Enabled = True
            btnStartScan.Enabled = True
        End If
        pnlSignonWait.Left = 338

    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ReDim ptrM201(10)
        ptrM201(0).Initialize()
        bCurPortIndex = 0
        fReadCfgReturn = False
        ReadCfgFile(0)
        If fReadCfgReturn = False Then
            msgs.Text = msgs.Text & "Error reading config file" & vbCrLf : System.Windows.Forms.Application.DoEvents()
            scrollText()
            Exit Sub
        End If
        ptrM201(bCurPortIndex).comPort = 6  'easiest just to hard-code for testng (mine is COM6)
    End Sub
    Public Sub ReadCfgFile(ByVal bIndex As Byte)
        Dim path As String = "201EWIN.CFG"
        Try
            Dim sr As StreamReader = New StreamReader(path)
            Do While sr.Peek() >= 0
                ptrM201(bIndex).TXQUEUESIZE = Val(sr.ReadLine())
                ptrM201(bIndex).RXQUEUESIZE = Val(sr.ReadLine())
                ptrM201(bIndex).baud = Val(sr.ReadLine())
                ptrM201(bIndex).comPort = Val(sr.ReadLine())
                txtCOM.Text = ptrM201(bIndex).comPort
                ptrM201(bIndex).scanInterval = Val(sr.ReadLine())
                ptrM201(bIndex).numChannels = Val(sr.ReadLine())
                ptrM201(bIndex).average = Val(sr.ReadLine())
                ptrM201(bIndex).tScan = Val(sr.ReadLine())
                ptrM201(bIndex).chan(0) = Val(sr.ReadLine())
                ptrM201(bIndex).chan(1) = Val(sr.ReadLine())
                ptrM201(bIndex).chan(2) = Val(sr.ReadLine())
                ptrM201(bIndex).chan(3) = Val(sr.ReadLine())
                ptrM201(bIndex).chan(4) = Val(sr.ReadLine())
                ptrM201(bIndex).chan(5) = Val(sr.ReadLine())
                ptrM201(bIndex).singleChan = Val(sr.ReadLine())
                ptrM201(bIndex).channel = Val(sr.ReadLine())
                comboChan.Text = CByte(ptrM201(bIndex).channel)
                ptrM201(bIndex).subChan = Val(sr.ReadLine())
                ptrM201(bIndex).wordCnt = Val(sr.ReadLine())
                ptrM201(bIndex).biPolar = Val(sr.ReadLine())
                ptrM201(bIndex).filter = Val(sr.ReadLine())
                ptrM201(bIndex).gain = Val(sr.ReadLine())
                ptrM201(bIndex).rate = Val(sr.ReadLine())
                ptrM201(bIndex).modeRegLo = Val(sr.ReadLine())
                ptrM201(bIndex).modeRegMid = Val(sr.ReadLine())
                ptrM201(bIndex).modeRegHi = Val(sr.ReadLine())
                localAvg = Val(sr.ReadLine())
            Loop
            sr.Close()
        Catch e As Exception
            MessageBox.Show(e.ToString())
            Exit Sub
        End Try
        fReadCfgReturn = True
    End Sub
    Private Sub btnGetVolts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetVolts.Click
        usRetVal = GetConversion(ptrM201(0))
        txtVolts.Text = Format((ptrM201(0).voltage) / 1000.0#, "#.000000  ")
    End Sub
    Private Sub txtCOM_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCOM.TextChanged
        ptrM201(0).comPort = txtCOM.Text
    End Sub
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Static tickCount As Long = 0
        If ptrM201(0).channel = 7 Then ptrM201(0).channel = 6 Else ptrM201(0).channel = 7
        comboChan.Text = ptrM201(0).channel
        usRetVal = SetChanCode(ptrM201(0))
        Sleep(500)
        usRetVal = GetConversion(ptrM201(0))
        txtVolts.Text = Format((ptrM201(0).voltage) / 1000.0#, "#.000000  ")
        tickCount += 1
        lblTimerCnt.Text = tickCount
    End Sub
    Private Sub btnTimer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTimer.Click
        If btnTimer.Text = "enable timer" Then
            Timer1.Enabled = True
            btnTimer.Text = "disable timer"
            btnSignon.Enabled = False
            btnGetVolts.Enabled = False
            btnStartScan.Enabled = False
        Else
            Timer1.Enabled = False
            btnTimer.Text = "enable timer"
            btnSignon.Enabled = True
            btnGetVolts.Enabled = True
            btnStartScan.Enabled = True
        End If
    End Sub
    Private Sub comboChan_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboChan.SelectedIndexChanged
        'these lines cause exception
        If IsNumeric(comboChan.Text) And fSignedOn Then
            ptrM201(0).channel = comboChan.Text
            usRetVal = SetChanCode(ptrM201(0))
        End If
    End Sub
    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs)
        msgs.Text = msgs.Text & "Reading config file" & vbCrLf : System.Windows.Forms.Application.DoEvents()
        scrollText()
        fReadCfgReturn = False
        msgs.Text = msgs.Text & "Signing on - wait . . ." & vbCrLf : System.Windows.Forms.Application.DoEvents()
        scrollText()
        'comPort is zero-based, so if your COM port in device manager is 1 then make this 0
        usRetVal = SignOn(ptrM201(bCurPortIndex))
        msgs.Text = msgs.Text & "SignOn return val: " & usRetVal & vbCrLf : System.Windows.Forms.Application.DoEvents()
        scrollText()
        If usRetVal Then
            msgs.Text = msgs.Text & "calibrating - wait . . ." & vbCrLf : System.Windows.Forms.Application.DoEvents()
            scrollText()
            usRetVal = SysCal(ptrM201(bCurPortIndex))      'set channel and subchannel
            fSignedOn = True
            usRetVal = GetConversion(ptrM201(bCurPortIndex)) 'returns millivolts to struct
            msgs.Text = msgs.Text & Format(ptrM201(bCurPortIndex).voltage / 1000, "#.000000") & vbCrLf
            scrollText()
            scrollText()
            btnGetVolts.Enabled = True
            btnTimer.Enabled = True
            comboChan.Enabled = True
        End If
    End Sub
    Private Sub btnStartScan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartScan.Click
        If btnStartScan.Text = "Stop Scan" Then
            GoTo EXIT_SCAN
        End If
        ptrM201(bCurPortIndex).numChannels = 1

        ptrM201(bCurPortIndex).channel = CByte(comboChan.Text)
        usRetVal = SetChanCode(ptrM201(bCurPortIndex))
        If usRetVal = 0 Then
            MsgBox("failed to set chan code")
            Exit Sub
        End If
        usRetVal = StartScanning(ptrM201(bCurPortIndex))
        If usRetVal = 0 Then
            MsgBox("failed to start scan")
            Exit Sub
        End If
        btnStartScan.Text = "Stop Scan"

        btnGetVolts.Enabled = False
        btnTimer.Enabled = False
        comboChan.Enabled = False

        Dim lForIndex As Integer
START_SCAN:
        lNumScansInBuffer = GetNumScansInBuffer(ptrM201(bCurPortIndex))
        txtScanBuff.Text = CInt(lNumScansInBuffer)
        For lForIndex = 1 To lNumScansInBuffer
            usRetVal = GetOneScan(ptrM201(bCurPortIndex))
            If usRetVal = 0 Then
                Select Case (ptrM201(bCurPortIndex).errorType)
                    Case 1
                        msgs.Text = msgs.Text & "framing error - exiting scan" & vbCrLf
                        scrollText()
                        btnStartScan.Text = "Start Scan" : GoTo EXIT_SCAN
                    Case 2
                        msgs.Text = msgs.Text & "not enough bytes for one scan - exiting scan" & vbCrLf
                        scrollText()
                        btnStartScan.Text = "Start Scan" : GoTo EXIT_SCAN
                    Case 3
                        msgs.Text = msgs.Text & "buffer overflow - exiting scan" & vbCrLf
                        scrollText()
                        btnStartScan.Text = "Start Scan" : GoTo EXIT_SCAN
                    Case 10
                        msgs.Text = msgs.Text & "scan rate too fast - exiting scan" & vbCrLf
                        scrollText()
                        btnStartScan.Text = "Start Scan" : GoTo EXIT_SCAN
                End Select
            End If
            usRetVal = Gconv(ptrM201(bCurPortIndex))
            txtScanVolts.Text = Format$(ptrM201(bCurPortIndex).voltage / 1000, "##.000000")
            Application.DoEvents()
        Next
        GoTo START_SCAN
EXIT_SCAN:
        usRetVal = StopScanning(ptrM201(bCurPortIndex))
        msgs.Text = msgs.Text & "scan stopped" & vbCrLf
        scrollText()
        btnStartScan.Text = "Start Scan"
        btnGetVolts.Enabled = True
        btnTimer.Enabled = True
        comboChan.Enabled = True
        btnStartScan.Enabled = True
    End Sub
    Sub scrollText()
        msgs.SelectionLength = 0
        msgs.SelectionStart = Len(msgs.Text)
        msgs.ScrollToCaret()
    End Sub

    Private Sub comboDbgLvl_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboDbgLvl.SelectedIndexChanged

    End Sub
 End Class

